############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
from twisted.python import log
from pyGridWare.generated.services.reliable_transfer_service.ReliableFileTransferService\
    import ReliableFileTransferServiceWSRF as WSRFService

class ReliableFileTransferService(WSRFService):
    """
    GetResourceContext
    NewResourceContextReliableFileTransferPortTypePort
    """

    def wsa_start(self, ps, address, **kw):
        log.msg("ReliableFileTransferService -- start", debug=True)
        request,response = WSRFService.wsa_start(self, ps, address)
        ctx = WSRFService.GetResourceContext(ps, address, **kw)
        return request,response

    def wsa_getStatus(self, ps, address, **kw):
        log.msg("ReliableFileTransferService -- getStatus", debug=True)
        request,response = WSRFService.wsa_getStatus(self, ps, address)
        return request,response

    def wsa_getStatusSet(self, ps, address, **kw):
        log.msg("ReliableFileTransferService -- getStatusSet", debug=True)
        request,response = WSRFService.wsa_getStatusSet(self, ps, address)
        return request,response

    def wsa_cancel(self, ps, address, **kw):
        log.msg("ReliableFileTransferService -- cancel", debug=True)
        request,response = WSRFService.wsa_cancel(self, ps, address)
        return request,response
