#!/usr/bin/env python
############################################################################
# Automatically generated by wsdl2web.py
# See LBNLCopyright for copyright notice!
###########################################################################
import os
from twisted.python import log
from twisted.internet import reactor

import ZSI
from pyGridWare.utility.scripts.client import GetBasicOptParser, GetPortKWArgs, SetUp
from pyGridWare.utility.generate import wsdl2web


"""Test script for globus container ContainerRegistryService.  Grabs the wsdl by querying
the service, generates code, then calls the service.

 ./container_registry_client.py -uhttp://131.243.2.159:8080/wsrf/services/ContainerRegistryService 


  <xsd:complexType name="EntryType">
    <xsd:sequence>
      <xsd:element name="ServiceGroupEntryEPR"
                   type="wsa:EndpointReferenceType" 
                   minOccurs="1" maxOccurs="1"
                   nillable="true"/>
      <xsd:element name="MemberServiceEPR"
                   type="wsa:EndpointReferenceType" 
                   minOccurs="1" maxOccurs="1"/>
      <xsd:element name="Content"
                   type="xsd:anyType" 
                   minOccurs="0" maxOccurs="1"/>
    </xsd:sequence>
  </xsd:complexType>
"""

def setup(options, wsdl):
    wsdl2web.run('%s?wsdl' %options.url, 
        force=True,
        config=os.path.join('config', 'server-config.txt'),
        tac=os.path.join('config', 'server-config.tac'))


def main(**kw):
    from generated.ContainerRegistryService.stubs import ContainerRegistryService as CLIENT
    locator = CLIENT.RegistryServiceLocator()
    port = locator.getRegistryPortTypePort(**kw)

    msg = CLIENT.GetResourcePropertyRequest(("http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ServiceGroup-1.2-draft-01.xsd", "Entry"))
    rsp = port.GetResourceProperty(msg)

    print "=="*30
    print "Container Registered Services"
    for i in xrange(len(rsp.Any)):
       entry = rsp.Any[i]
       entry.ServiceGroupEntryEPR
       entry.MemberServiceEPR
       entry.Content

       if not entry.ServiceGroupEntryEPR.ReferenceProperties: 
           print "[%d]: Unknown??" %(i)
           continue

       name = entry.ServiceGroupEntryEPR.ReferenceProperties.Any[0]
       if not entry.MemberServiceEPR.Address: 
           print "[%d]: %s" %(i, name)
           continue

       print "[%d]: %s" %(i, entry.MemberServiceEPR.Address)

    print "=="*30
    reactor.stop()
    return


if __name__ == '__main__':
    op = GetBasicOptParser()
    (options, args) = op.parse_args()
    SetUp(options)
    kw = GetPortKWArgs(options)

    reactor.callWhenRunning(setup, options, args)
    reactor.callWhenRunning(main, **kw)
    reactor.run()


