############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
from pyGridWare.security.authz.resource import ResourcePortal
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from generated.counter_service.services.counter_service.CounterService\
     import CounterServiceWSRF as WSRFService
from generated.counter_service.services.counter_service.CounterService\
      import ManagerHome


class Counter(WSRFService):
    wsdl = "../share/schema/core/samples/counter/counter_flattened.wsdl"

    def wsa_add(self, ps, address, **kw):
        # Get request and response
        request,response = WSRFService.wsa_add(self, ps, address, **kw)

        # Get Resource Context
        ctx = WSRFService.GetResourceContext(ps, address, request=kw['request'])

        # Access resource properties, and evaluate new value.
        counter = ctx.properties
        result = counter.Value
        result += request
        counter.Value = result

        # response is immutable instance, create new one with result.
        response = response.__class__(result)
        return request,response

    def wsa_createCounter(self, ps, address, **kw):
        # Get request and response
        request,response = WSRFService.wsa_createCounter(self, ps, address, **kw)

        # Create Resource Context
        ctx = self.NewResourceContextCounterPortTypePort(kw['request'])

        # Initialize Value to 0
        counter = ctx.properties
        counter.Value = 0

        # Create EndPointReference and set in response
        epr = AddressingUtils.createEndpointReference(ctx)
        response._EndpointReference = epr
        return request,response


resource = ResourcePortal(Counter())
