###########################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import os
from pyGridWare.services.SecureConversationService import SecureConversationService
from pyGridWare.utility.gsi import get_calist, GSIServerContextFactory

capath = os.path.join('etc', 'grid-security', 'certificates')
contextFactory = GSIServerContextFactory(\
                    privateKeyFileName=os.path.join('etc', 'grid-security', 'containerkey.pem'),
                    certificateFileName=os.path.join('etc', 'grid-security', 'containercert.pem'),
                    calist=get_calist(capath),
                    capath=capath)

resource = SecureConversationService(contextFactory)
